// GM_info 由 XLGreaseMonkey.java 写入
// const GM_info = {
//    script: {
//        namespace: "x-gm-space",
//        name: "gm"
//    },
//    uuid: ''
// }

// 以下【//!!!TEMPLATE!!!】不要改动，XLGreaseMonkey.java 用来匹配开始
//!!!TEMPLATE!!!

// unsafeWindow as window
unsafeWindow = window;

// GM_xxx api
const GM_addStyle = function(css) {
    return window.XGM.addStyle(GM_info, css);
};

const GM_addElement = function(...args) { // (tag_name, attributes) or (parent_node, tag_name, attributes)
    return window.XGM.addElement(GM_info, args);
};

const GM_deleteValue = function(name) {
    return window.XGM.deleteValue(GM_info, name);
};

const GM_listValues = function() {
    return window.XGM.listValues(GM_info);
};

const GM_addValueChangeListener = function(name, callback) { // callback: function(name, old_value, new_value, remote) {}
    return window.XGM.addValueChangeListener(GM_info, name, callback);
};

const GM_removeValueChangeListener = function(listener_id) {
    return window.XGM.removeValueChangeListener(GM_info, listener_id);
};

const GM_setValue = function(name, value) {
    return window.XGM.setValue(GM_info, name, value);
};

const GM_getValue = function(name, defaultValue) {
    return window.XGM.getValue(GM_info, name, defaultValue);
};

const GM_log = function(message) {
    return window.XGM.log(GM_info, message);
};

const GM_getResourceText = function(name) {
    return window.XGM.getResourceText(GM_info, name);
};

const GM_getResourceURL = function(name) {
    return window.XGM.getResourceURL(GM_info, name);
};

const GM_registerMenuCommand = function(name, fn, accessKey) {
    return window.XGM.registerMenuCommand(GM_info, name, fn, accessKey);
};

const GM_unregisterMenuCommand = function(menuCmdId) {
    return window.XGM.unregisterMenuCommand(GM_info, menuCmdId);
};

const GM_openInTab = function(url, extra) { // (url, options) or (url, loadInBackground)
    return window.XGM.openInTab(GM_info, url, extra);
};

const GM_xmlhttpRequest = function(details) {
    return window.XGM.xmlhttpRequest(GM_info, details);
};

const GM_download = function(...args) { //(details) or (url, name)
    return window.XGM.download(GM_info, args);
};

const GM_getTab = function(callback) {
    return window.XGM.getTab(GM_info, callback);
};

const GM_saveTab = function(tab) {
    return window.XGM.saveTab(GM_info, tab);
};

const GM_getTabs = function(callback) {
    return window.XGM.getTabs(GM_info, callback);
};

const GM_notification = function(...args) { //(details, ondone) or (text, title, image, onclick)
    return window.XGM.notification(GM_info, args);
};

const GM_setClipboard = function(data, info) {
    return window.XGM.setClipboard(GM_info, data, info);
};
